iOS7-Sampler
============

Code examples for the new functions of iOS 7.

![](http://f.cl.ly/items/1t250s1N3z0c1g2H1N0P/iOS7Sampler1_r1_c1.png)


##Contents

###Dynamic Behaviors

Dynamic Behaviours using UIDynamicAnimator, UIGravityBehavior, UICollisionBehavior, UIDynamicItemBehavior.

![](http://f.cl.ly/items/3M2b110A141D1O0C0D0e/dynamics1__.png)

###Speech Synthesis

Synthesized speech from text using AVSpeechSynthesizer and AVSpeechUtterance.

![](http://f.cl.ly/items/3y0i3B0R3O3E1N1s1w20/speech___.png)

###Custom Transition

UIViewControllerAnimatedTransitioning, UIViewControllerTransitioningDelegate.

- [ZBCustomTransitions](https://github.com/zonble/ZBCustomTransitions)

![](http://f.cl.ly/items/2P0a2Z3W0W2P3p1W2L0X/transition_lines.png)


- [HUAnimator](https://github.com/cinkster/HUAnimator)

![](http://f.cl.ly/items/2S0X383R2T1j1X2Y1e3t/transition_gravity.png)


###3D Map

3D Map using MKMapCamera.

![](http://f.cl.ly/items/0R2T2a2s1A3s1G2n3I25/3DMap_.png)


###Smile Detection

Smile Detection using CIDetectorSmile and new properties of CIFeature such as "bounds".

![smile_.png](https://qiita-image-store.s3.amazonaws.com/0/3180/6b5202e3-749d-d5f8-88ba-1877290e33b2.png)


###Image Filters

New filters of CIFilter.


- CILinearToSRGBToneCurve
- CIPhotoEffectChrome
- CIPhotoEffectFade
- CIPhotoEffectInstant
- CIPhotoEffectMono
- CIPhotoEffectNoir
- CIPhotoEffectProcess
- CIPhotoEffectTonal
- CIPhotoEffectTransfer
- CISRGBToneCurveToLinear
- CIVignetteEffect


![](http://f.cl.ly/items/3K0T3c012o062b0o061c/imagefilters__.png)


###Sprite Kit

A sample of Sprite Kit using SKView, SKScene, SKSpriteNode, SKAction.

![](https://qiita-image-store.s3.amazonaws.com/0/3180/98fcfb76-5ac4-6c3b-cfca-a008790c948a.png)


###Map Directions

Requesting and draw directions using MKDirections, MKDirectionsResponse and MKPolylineRenderer.

![mapdirection_.png](https://qiita-image-store.s3.amazonaws.com/0/3180/3fe4c6f3-4d3d-0fd2-92ee-e5ffcac51b8e.png)

###Motion Effects (Parallax)

Parallax effect using UIMotionEffect.

![](http://f.cl.ly/items/3L2N2m3M1i0G45081o0j/parallax_.png)


###Multipeer Connectivity

Creating a local network sharing connection over Wi-Fi or Bluetooth LE.

![](http://f.cl.ly/items/3T432y3G1w1S1u2W0X0q/multipeer.png)


###AirDrop/Flickr/Vimeo/ReadingList

New Activity Types: AirDrop, Post to Flickr / Vimeo, Add to ReadingList

![](http://f.cl.ly/items/2V2E3P2f1X1z0E0E0E47/AirDrop_.png)


###QR Code Generator

Generating QR Code with CIQRCodeGenerator.

![](http://f.cl.ly/items/3E1q1t1L2n142r2i2I3S/qrcode__.png)


###Motion Activity Tracking

Counting steps and monitoring the activity using CMStepCounter and CMMotionActivityManager. It works only on iPhone5s (M7 chip).

![](http://f.cl.ly/items/391o07450F3U443B3i0v/m7_.png)


###Static Map Snapshots

Creating a snapshot with MKMapSnapshotOptions, MKMapSnapshotter.

![](http://f.cl.ly/items/2Q3d472D37002f063716/map_snapshot.png)


###Safari Reading List

Adding an item to the Safari Reading List with the new Safari Services framework.


###New Fonts

Displaying new fonts with their FontNames which are needed for \"fontWithName:size:\" method of UIFont.

![](http://f.cl.ly/items/2i1P390S0f3K340i0p1G/font2_.png)


##See Also

###[Open source collection for Flat Design UI](http://d.hatena.ne.jp/shu223/20130617/1371606128)

A collection of OSS which helps you **implement Flat Design UI on your current version of iOS (iOS5,6) just like that on iOS 7.**
